/* Copyright (c) IBM Corp. 1992 */
 

template < class Element, class Key >
INumber IARelation < Element, Key >::
numberOfOccurrences (Element const& element) const
{ if (contains (element))
    return 1;
  else
    return 0;
}

template < class Element, class Key >
Boolean IARelation < Element, Key >::
locateNext (Element const&, ICursor& cursor) const
{ cursor.invalidate ();
  return False;
}

template < class Element, class Key >
INumber IARelation < Element, Key >::
removeAllOccurrences (Element const& element)
{ if (remove (element))
    return 1;
  else
    return 0;
}

template < class Element, class Key >
Boolean IARelation < Element, Key >::
operator == (IARelation < Element, Key > const& collection) const
{ return this->containsAllFrom (collection) &&
	 collection.containsAllFrom (*this);
}

template < class Element, class Key >
Boolean IARelation < Element, Key >::
operator != (IARelation < Element, Key > const& collection) const
{ return ! operator == (collection);
}

template < class Element, class Key >
void IARelation < Element, Key >::
unionWith (IARelation < Element, Key > const& collection)
{ addAllFrom (collection);
}

template < class Element, class Key >
void IARelation < Element, Key >::
intersectionWith (IARelation < Element, Key > const& collection)
{ IAEqualityCollection < Element > const* env = &collection;
  removeAll (IAEqualityCollection < Element >::isNotContained, &env);
}

template < class Element, class Key >
void IARelation < Element, Key >::
differenceWith (IARelation < Element, Key > const& collection)
{ IAEqualityCollection < Element > const* env = &collection;
  removeAll (IAEqualityCollection < Element >::isContained, &env);
}

template < class Element, class Key >
void IARelation < Element, Key >::
addUnion (IARelation < Element, Key > const& collection1,
          IARelation < Element, Key > const& collection2)
{ addAllFrom (collection1);
  addAllFrom (collection2);
}

template < class Element, class Key >
void IARelation < Element, Key >::
addIntersection (IARelation < Element, Key > const& collection1,
                 IARelation < Element, Key > const& collection2)
{ ICursor *cursor = collection1.newCursor ();
  forCursor (*cursor) {
    if (collection2.contains (collection1.elementAt (*cursor)))
      add (collection1.elementAt (*cursor));
  }
  delete cursor;
}

template < class Element, class Key >
void IARelation < Element, Key >::
addDifference (IARelation < Element, Key > const& collection1,
               IARelation < Element, Key > const& collection2)
{ ICursor *cursor = collection1.newCursor ();
  forCursor (*cursor) {
    if (! collection2.contains (collection1.elementAt (*cursor)))
      add (collection1.elementAt (*cursor));
  }
  delete cursor;
}

